
local 	DF = _G ["DetailsFramework"]

--TODO
--continue fixing duplicate roll numbers
--Notify inspect (check GUID, cancel after getting info)

if (not DF) then
	print ("|cFFFFAA00Personal Loot Trader: framework not found, if you just installed or updated the addon, please restart your client.|r")
	return
end

local L = LibStub ("AceLocale-3.0"):GetLocale ("PersonalLootTrader", true)
if (not L) then
	print ("|cFFFFAA00Personal Loot Trader|r: Reopen your client to finish updating the addon.|r")
	return
end

local ptexture = LibStub:GetLibrary ("LibSharedMedia-3.0"):Fetch ("statusbar", "Iskar Serenity")
local MAX_ROLLS = 10
local canUse = {}
local slotsOpen = {}
local slotAssoc = {}
local RollFrames = {}
local inRange = {}
local ITEM_CLASSES_ALLOWED_PATTERN = _G.ITEM_CLASSES_ALLOWED:gsub('%%s', '(.+)')		-- Classes: (.+)

--local tooltipLong

local addonName, addon = ...
local PLTrader = addon
local PLT = addon
local PLRFrame

local MSAbrev = L["S_MainSpecAbreviation"]
local OSAbrev = L["S_OffSpecAbreviation"]


local EF = CreateFrame('Frame') -- event handler frame
EF:RegisterEvent("CHAT_MSG_ADDON")
EF:SetScript('OnEvent', function(self, event, ...) self[event](self, ...) end)

local ECP = CreateFrame('Frame') -- chat parser


local ARMOR_BY_SPEC = {
	[1]						= {LE_ITEM_ARMOR_PLATE}, --Warrior
	[2]						= {LE_ITEM_ARMOR_PLATE}, --Pally
	[3]						= {LE_ITEM_ARMOR_MAIL}, --Hunter
	[4]						= {LE_ITEM_ARMOR_LEATHER},--Rogue
	[5]						= {LE_ITEM_ARMOR_CLOTH}, --Priest
	[6]						= {LE_ITEM_ARMOR_PLATE}, --DK
	[7]						= {LE_ITEM_ARMOR_MAIL}, --Shaman
	[8]						= {LE_ITEM_ARMOR_CLOTH}, --Mage
	[9]						= {LE_ITEM_ARMOR_CLOTH}, --Warlock
	[10]					= {LE_ITEM_ARMOR_LEATHER}, --Monk
	[11]					= {LE_ITEM_ARMOR_LEATHER}, --Druid
	[12]					= {LE_ITEM_ARMOR_LEATHER}, --DH
	
	[250]					= {LE_ITEM_ARMOR_PLATE}, --Blood DK
	[251]					= {LE_ITEM_ARMOR_PLATE}, --Frost DK
	[252]					= {LE_ITEM_ARMOR_PLATE}, --UnholyDK
	[577]					= {LE_ITEM_ARMOR_LEATHER}, --Havoc DH
	[581]				    = {LE_ITEM_ARMOR_LEATHER}, --Veng DH
	[102]					= {LE_ITEM_ARMOR_LEATHER}, --Bal Druid
	[103]					= {LE_ITEM_ARMOR_LEATHER},--Feral Druid
	[104]					= {LE_ITEM_ARMOR_LEATHER}, --Guard Druid
	[105]					= {LE_ITEM_ARMOR_LEATHER}, --Resto Druid
	[253]					= {LE_ITEM_ARMOR_MAIL},--BM Hunter
	[254]					= {LE_ITEM_ARMOR_MAIL},--Marks Hunter
	[255]					= {LE_ITEM_ARMOR_MAIL}, --Surv Hunter
	[62]					= {LE_ITEM_ARMOR_CLOTH},--Arcane Mage
	[63]					= {LE_ITEM_ARMOR_CLOTH},--Fire Mage
	[64]					= {LE_ITEM_ARMOR_CLOTH},--Frost Mage
	[268]					= {LE_ITEM_ARMOR_LEATHER},--BM Monk
	[270]					= {LE_ITEM_ARMOR_LEATHER}, --MW Monk
	[269]					= {LE_ITEM_ARMOR_LEATHER}, --WW Monk
	[65]					= {LE_ITEM_ARMOR_PLATE, LE_ITEM_ARMOR_SHIELD}, --Holy Pally
	[66]					= {LE_ITEM_ARMOR_PLATE, LE_ITEM_ARMOR_SHIELD},--Prot Pally
	[70]					= {LE_ITEM_ARMOR_PLATE}, --Ret Pally
	[256]					= {LE_ITEM_ARMOR_CLOTH}, --Disc Priest
	[257]					= {LE_ITEM_ARMOR_CLOTH}, --Holy Priest
	[258]			   	 	= {LE_ITEM_ARMOR_CLOTH},--Shadow Priest
	[259]					= {LE_ITEM_ARMOR_LEATHER}, --ass rogue
	[260]					= {LE_ITEM_ARMOR_LEATHER},--Out rogue
	[261]					= {LE_ITEM_ARMOR_LEATHER}, --Sub rogue
	[262]					= {LE_ITEM_ARMOR_MAIL, LE_ITEM_ARMOR_SHIELD}, --Ele Shaman
	[263]					= {LE_ITEM_ARMOR_MAIL}, --Enhance Shaman
	[264]					= {LE_ITEM_ARMOR_MAIL, LE_ITEM_ARMOR_SHIELD},--Resto Shaman
	[265]					= {LE_ITEM_ARMOR_CLOTH}, --Affliction Lock
	[266]					= {LE_ITEM_ARMOR_CLOTH}, --Demo Lock
	[267]			   		= {LE_ITEM_ARMOR_CLOTH}, --Destro Lock
	[71]					= {LE_ITEM_ARMOR_PLATE}, --Arms Warrior
	[72]					= {LE_ITEM_ARMOR_PLATE}, -- Fury Warrior
	[73]					= {LE_ITEM_ARMOR_PLATE, LE_ITEM_ARMOR_SHIELD}, --Prot Warrior	
    [1467]                  = {LE_ITEM_ARMOR_MAIL}, -- Devastation Evoker
    [1468]                  = {LE_ITEM_ARMOR_MAIL} -- Preservation Evoker
}

local WEAPON_BY_SPEC = {
	[250]					= {LE_ITEM_WEAPON_AXE2H, LE_ITEM_WEAPON_MACE2H, LE_ITEM_WEAPON_POLEARM, LE_ITEM_WEAPON_SWORD2H }, --Blood DK
	[251]					= {LE_ITEM_WEAPON_AXE1H, LE_ITEM_WEAPON_MACE1H, LE_ITEM_WEAPON_SWORD1H }, --Frost DK
	[252]					= {LE_ITEM_WEAPON_AXE2H, LE_ITEM_WEAPON_MACE2H, LE_ITEM_WEAPON_POLEARM, LE_ITEM_WEAPON_SWORD2H }, --UnholyDK
	[577]					= {LE_ITEM_WEAPON_AXE1H, LE_ITEM_WEAPON_SWORD1H, LE_ITEM_WEAPON_UNARMED}, --Havoc DH
	[581]				    = {LE_ITEM_WEAPON_AXE1H, LE_ITEM_WEAPON_SWORD1H, LE_ITEM_WEAPON_UNARMED }, --Veng DH
	[102]					= {LE_ITEM_WEAPON_DAGGER, LE_ITEM_WEAPON_MACE1H, LE_ITEM_WEAPON_MACE2H, LE_ITEM_WEAPON_POLEARM, LE_ITEM_WEAPON_STAFF, LE_ITEM_WEAPON_UNARMED }, --Bal Druid
	[103]					= {LE_ITEM_WEAPON_MACE2H, LE_ITEM_WEAPON_POLEARM, LE_ITEM_WEAPON_STAFF },--Feral Druid
	[104]					= {LE_ITEM_WEAPON_MACE2H, LE_ITEM_WEAPON_POLEARM, LE_ITEM_WEAPON_STAFF }, --Guard Druid
	[105]					= {LE_ITEM_WEAPON_DAGGER, LE_ITEM_WEAPON_MACE1H, LE_ITEM_WEAPON_MACE2H, LE_ITEM_WEAPON_POLEARM, LE_ITEM_WEAPON_STAFF, LE_ITEM_WEAPON_UNARMED }, --Resto Druid
	[253]					= {LE_ITEM_WEAPON_BOWS, LE_ITEM_WEAPON_CROSSBOW, LE_ITEM_WEAPON_GUNS },--BM Hunter
	[254]					= {LE_ITEM_WEAPON_BOWS, LE_ITEM_WEAPON_CROSSBOW, LE_ITEM_WEAPON_GUNS },--Marks Hunter
	[255]					= {LE_ITEM_WEAPON_POLEARM, LE_ITEM_WEAPON_STAFF}, --Surv Hunter
	[62]					= {LE_ITEM_WEAPON_DAGGER, LE_ITEM_WEAPON_STAFF, LE_ITEM_WEAPON_SWORD1H, LE_ITEM_WEAPON_WAND },--Arcane Mage
	[63]					= {LE_ITEM_WEAPON_DAGGER, LE_ITEM_WEAPON_STAFF, LE_ITEM_WEAPON_SWORD1H, LE_ITEM_WEAPON_WAND },--Fire Mage
	[64]					= {LE_ITEM_WEAPON_DAGGER, LE_ITEM_WEAPON_STAFF, LE_ITEM_WEAPON_SWORD1H, LE_ITEM_WEAPON_WAND },--Frost Mage
	[268]					= {LE_ITEM_WEAPON_POLEARM, LE_ITEM_WEAPON_STAFF },--BM Monk
	[270]					= {LE_ITEM_WEAPON_AXE1H, LE_ITEM_WEAPON_MACE1H, LE_ITEM_WEAPON_POLEARM, LE_ITEM_WEAPON_STAFF, LE_ITEM_WEAPON_SWORD1H, LE_ITEM_WEAPON_UNARMED }, --MW Monk
	[269]					= {LE_ITEM_WEAPON_AXE1H, LE_ITEM_WEAPON_MACE1H, LE_ITEM_WEAPON_SWORD1H, LE_ITEM_WEAPON_UNARMED }, --WW Monk
	[65]					= {LE_ITEM_WEAPON_AXE1H, LE_ITEM_WEAPON_MACE1H, LE_ITEM_WEAPON_MACE2H, LE_ITEM_WEAPON_POLEARM, LE_ITEM_WEAPON_SWORD1H, LE_ITEM_WEAPON_SWORD2H }, --Holy Pally
	[66]					= {LE_ITEM_WEAPON_AXE1H, LE_ITEM_WEAPON_MACE1H, LE_ITEM_WEAPON_SWORD1H },--Prot Pally
	[70]					= {LE_ITEM_WEAPON_AXE2H, LE_ITEM_WEAPON_MACE2H, LE_ITEM_WEAPON_POLEARM, LE_ITEM_WEAPON_SWORD2H }, --Ret Pally
	[256]					= {LE_ITEM_WEAPON_DAGGER, LE_ITEM_WEAPON_MACE1H, LE_ITEM_WEAPON_STAFF, LE_ITEM_WEAPON_WAND }, --Disc Priest
	[257]					= {LE_ITEM_WEAPON_DAGGER, LE_ITEM_WEAPON_MACE1H, LE_ITEM_WEAPON_STAFF, LE_ITEM_WEAPON_WAND }, --Holy Priest
	[258]			   	 	= {LE_ITEM_WEAPON_DAGGER, LE_ITEM_WEAPON_MACE1H, LE_ITEM_WEAPON_STAFF, LE_ITEM_WEAPON_WAND },--Shadow Priest
	[259]					= {LE_ITEM_WEAPON_DAGGER }, --ass rogue
	[260]					= {LE_ITEM_WEAPON_AXE1H, LE_ITEM_WEAPON_MACE1H, LE_ITEM_WEAPON_SWORD1H, LE_ITEM_WEAPON_UNARMED },--Out rogue
	[261]					= {LE_ITEM_WEAPON_DAGGER }, --Sub rogue
	[262]					= {LE_ITEM_WEAPON_DAGGER, LE_ITEM_WEAPON_AXE1H, LE_ITEM_WEAPON_MACE1H, LE_ITEM_WEAPON_MACE2H, LE_ITEM_WEAPON_STAFF, LE_ITEM_WEAPON_UNARMED }, --Ele Shaman
	[263]					= {LE_ITEM_WEAPON_AXE1H, LE_ITEM_WEAPON_MACE1H, LE_ITEM_WEAPON_UNARMED }, --Enhance Shaman
	[264]					= {LE_ITEM_WEAPON_DAGGER, LE_ITEM_WEAPON_AXE1H, LE_ITEM_WEAPON_MACE1H, LE_ITEM_WEAPON_MACE2H, LE_ITEM_WEAPON_STAFF, LE_ITEM_WEAPON_UNARMED },--Resto Shaman
	[265]					= {LE_ITEM_WEAPON_DAGGER, LE_ITEM_WEAPON_STAFF, LE_ITEM_WEAPON_SWORD1H, LE_ITEM_WEAPON_WAND }, --Affliction Lock
	[266]					= {LE_ITEM_WEAPON_DAGGER, LE_ITEM_WEAPON_STAFF, LE_ITEM_WEAPON_SWORD1H, LE_ITEM_WEAPON_WAND }, --Demo Lock
	[267]			   		= {LE_ITEM_WEAPON_DAGGER, LE_ITEM_WEAPON_STAFF, LE_ITEM_WEAPON_SWORD1H, LE_ITEM_WEAPON_WAND }, --Destro Lock
	[71]					= {LE_ITEM_WEAPON_AXE2H, LE_ITEM_WEAPON_MACE2H, LE_ITEM_WEAPON_POLEARM, LE_ITEM_WEAPON_SWORD2H }, --Arms Warrior
	[72]					= {LE_ITEM_WEAPON_AXE2H, LE_ITEM_WEAPON_MACE2H, LE_ITEM_WEAPON_POLEARM, LE_ITEM_WEAPON_SWORD2H }, -- Fury Warrior
	[73]					= {LE_ITEM_WEAPON_AXE1H, LE_ITEM_WEAPON_MACE1H, LE_ITEM_WEAPON_SWORD1H }, --Prot Warrior
    [1467]                  = {LE_ITEM_WEAPON_DAGGER, LE_ITEM_WEAPON_SWORD1H, LE_ITEM_WEAPON_STAFF, LE_ITEM_WEAPON_MACE1H}, -- Devastation Evoker
    [1468]                  = {LE_ITEM_WEAPON_DAGGER, LE_ITEM_WEAPON_SWORD1H, LE_ITEM_WEAPON_STAFF, LE_ITEM_WEAPON_MACE1H}
}

local STAT_BY_SPEC = {
	-- [1]						= {_G.ITEM_MOD_STRENGTH_SHORT }, --Warrior
	-- [2]						= {_G.ITEM_MOD_STRENGTH_SHORT, ITEM_MOD_INTELLECT_SHORT}, --Pally
	-- [3]						= {_G.ITEM_MOD_AGILITY_SHORT}, --Hunter
	-- [4]						= {_G.ITEM_MOD_AGILITY_SHORT},--Rogue
	-- [5]						= {_G.ITEM_MOD_INTELLECT_SHORT}, --Priest
	-- [6]						= {_G.ITEM_MOD_STRENGTH_SHORT}, --DK
	-- [7]						= {_G.ITEM_MOD_AGILITY_SHORT, ITEM_MOD_INTELLECT_SHORT}, --Shaman
	-- [8]						= {_G.ITEM_MOD_INTELLECT_SHORT}, --Mage
	-- [9]						= {_G.ITEM_MOD_INTELLECT_SHORT}, --Warlock
	-- [10]					= {_G.ITEM_MOD_INTELLECT_SHORT, ITEM_MOD_AGILITY_SHORT}, --Monk
	-- [11]					= {_G.ITEM_MOD_INTELLECT_SHORT, ITEM_MOD_AGILITY_SHORT}, --Druid
	-- [12]					= {_G.ITEM_MOD_AGILITY_SHORT}, --DH
	[250]					= {_G.ITEM_MOD_STRENGTH_SHORT}, --Blood DK
	[251]					= {_G.ITEM_MOD_STRENGTH_SHORT }, --Frost DK
	[252]					= {_G.ITEM_MOD_STRENGTH_SHORT }, --UnholyDK
	[577]					= {_G.ITEM_MOD_AGILITY_SHORT}, --Havoc DH
	[581]				    = {_G.ITEM_MOD_AGILITY_SHORT}, --Veng DH
	[102]					= {_G.ITEM_MOD_INTELLECT_SHORT}, --Bal Druid
	[103]					= {_G.ITEM_MOD_AGILITY_SHORT},--Feral Druid
	[104]					= {_G.ITEM_MOD_AGILITY_SHORT}, --Guard Druid
	[105]					= {_G.ITEM_MOD_INTELLECT_SHORT}, --Resto Druid
	[253]					= {_G.ITEM_MOD_AGILITY_SHORT},--BM Hunter
	[254]					= {_G.ITEM_MOD_AGILITY_SHORT},--Marks Hunter
	[255]					= {_G.ITEM_MOD_AGILITY_SHORT}, --Surv Hunter
	[62]					= {_G.ITEM_MOD_INTELLECT_SHORT},--Arcane Mage
	[63]					= {_G.ITEM_MOD_INTELLECT_SHORT},--Fire Mage
	[64]					= {_G.ITEM_MOD_INTELLECT_SHORT},--Frost Mage
	[268]					= {_G.ITEM_MOD_AGILITY_SHORT},--BM Monk
	[270]					= {_G.ITEM_MOD_INTELLECT_SHORT}, --MW Monk
	[269]					= {_G.ITEM_MOD_AGILITY_SHORT}, --WW Monk
	[65]					= {_G.ITEM_MOD_INTELLECT_SHORT}, --Holy Pally
	[66]					= {_G.ITEM_MOD_STRENGTH_SHORT},--Prot Pally
	[70]					= {_G.ITEM_MOD_STRENGTH_SHORT}, --Ret Pally
	[256]					= {_G.ITEM_MOD_INTELLECT_SHORT}, --Disc Priest
	[257]					= {_G.ITEM_MOD_INTELLECT_SHORT}, --Holy Priest
	[258]			    	= {_G.ITEM_MOD_INTELLECT_SHORT},--Shadow Priest
	[259]					= {_G.ITEM_MOD_AGILITY_SHORT}, --ass rogue
	[260]					= {_G.ITEM_MOD_AGILITY_SHORT},--Out rogue
	[261]					= {_G.ITEM_MOD_AGILITY_SHORT}, --Sub rogue
	[262]					= {_G.ITEM_MOD_INTELLECT_SHORT}, --Ele Shaman
	[263]					= {_G.ITEM_MOD_AGILITY_SHORT}, --Enhance Shaman
	[264]					= {_G.ITEM_MOD_INTELLECT_SHORT},--Resto Shaman
	[265]					= {_G.ITEM_MOD_INTELLECT_SHORT}, --Affliction Lock
	[266]					= {_G.ITEM_MOD_INTELLECT_SHORT}, --Demo Lock
	[267]			    	= {_G.ITEM_MOD_INTELLECT_SHORT}, --Destro Lock
	[71]					= {_G.ITEM_MOD_STRENGTH_SHORT}, --Arms Warrior
	[72]					= {_G.ITEM_MOD_STRENGTH_SHORT}, -- Fury Warrior
	[73]					= {_G.ITEM_MOD_STRENGTH_SHORT}, --Prot Warrior
    [1467]                  = {_G.ITEM_MOD_INTELLECT_SHORT}, -- Devastation Evoker
    [1468]                  = {_G.ITEM_MOD_INTELLECT_SHORT} -- Preservation Evoker
}

local OFFHANDS_USABLE = { --No offhand checking in other one?
	--[2]					= true, --Pally
	--[3]					= true, --Hunter
	--[4]					= true,--Rogue
	[5]						= true, --Priest
	--[6]					= true, --DK
	[7]						= true, --Shaman
	[8]						= true, --Mage
	[9]						= true, --Warlock
	[10]					= true, --Monk
	[11]					= true, --Druid
	--[12]					= true, --DH
	--[250]					= true, --Blood DK
	--[251]					= true, --Frost DK
	--[252]					= true, --UnholyDK
--	[577]					= true, --Havoc DH
	--[581]				    = true, --Veng DH
	[102]					= true, --Bal Druid
	--[103]					= true,--Feral Druid
	--[104]					= true, --Guard Druid
	[105]					= true, --Resto Druid
	--[253]					= true,--BM Hunter
	--[254]					= true,--Marks Hunter
	--[255]					= true, --Surv Hunter
	[62]					= true,--Arcane Mage
	[63]					= true,--Fire Mage
	[64]					= true,--Frost Mage
	--[268]					= true,--BM Monk
	[270]					= true, --MW Monk
	--[269]					= true, --WW Monk
	--[65]					= true, --Holy Pally
	--[66]					= true,--Prot Pally
	--[70]					= true, --Ret Pally
	[256]					= true, --Disc Priest
	[257]					= true, --Holy Priest
	[258]			    	= true,--Shadow Priest
	--[259]					= true, --ass rogue
	--[260]					= true,--Out rogue
	--[261]					= true, --Sub rogue
	[262]					= true, --Ele Shaman
	--[263]					= true, --Enhance Shaman
	[264]					= true,--Resto Shaman
	[265]					= true, --Affliction Lock
	[266]					= true, --Demo Lock
	[267]			    	= true, --Destro Lock
	--[71]					= true, --Arms Warrior
	--[72]					= true, -- Fury Warrior
	--[73]					= true --Prot Warrior
    [1467]                  = true, -- Devastation Evoker
    [1468]                  = true
}

local function isDebugging()
	if PLTrader.db.profile.general.debugging then
		return true
	end
end

local function updateFrameHeight() --merge with PLT:RemoveSlot?

	local ii=MAX_ROLLS
	local useSlot
	repeat --Check if there's no loot open
		ii=ii-1
		useSlot = slotsOpen[ii]
	until useSlot ~= nil or ii == 0

	if ii == 0 then
		PLRFrame:Hide()
		EF:UnregisterEvent("TRADE_CLOSED")
		EF:UnregisterEvent("TRADE_SHOW")
	else
		PLRFrame:Show()
	end
	
	PLRFrame.Backdrop:SetHeight((ii*79)+25)

end

local function startNewItemRoll(MSNum, sender, msgTable, itemLink, force)
	--force makes it not check if it is equippable. This is for if you manually roll on an item
	--and win then the trade window will show up with no errors. Kinda sloppy.

	local slot = slotAssoc[sender] --If the sender already has an item up then cancel it
	if slot then PLT:RemoveSlot(slot) end
	
	PLT:DebugPrint("SENT BY:  " .. sender)

    if not force then
        if MSNum == 100 then
            if PLT:IsPlayer(sender) then PLT:SendStartMessage() end
        else
            --print(MSNum, PLT:IsNumInUse(MSNum))
            if PLT:IsPlayer(sender) then
                if PLT:IsNumInUse(MSNum) then
                    --Don't ask me why the roll number is refreshed inside the example text func
                    --I had no idea what I was doing when I made this addon.
                    PLT:UpdateExampleText(true)
                    PLT:StartGroupRoll()
                    PLT:Print(L["S_DUPLICATE_ROLL_NUM"])
                    return
                else
                    PLT:SendStartMessage()
                end
            end
            PLT:AddUseNumber(MSNum)
        end
    end

    if (PLT:IsPlayer(sender)) and not PLTrader.db.profile.general.debugging then return end

	local i = 0
	local f
	repeat
		i=i+1
		f = RollFrames[i]
	until not f or (f and not f.storage.sender)
	
	if i <= MAX_ROLLS then
		slotsOpen[i] = false
		slotAssoc[sender] = i
		local item = Item:CreateFromItemLink(itemLink)
		
		item:ContinueOnItemLoad(function()
			PLT:CreateLootFrame(i, msgTable, "PLT", sender, force)
		end)
		
	else
		print("Can't go above 10 rolls. How did this even happen?")
	end

end

--Updates the text on trade button when moving closer and farther
local function updateTradeButton(slot, sender)
	--print(sender)
	PLT:UpdateTradeButton(sender, RollFrames[slot].TradeButton)
	
	if RollFrames[slot].awaitingTrade then
		C_Timer.After(1, function() updateTradeButton(slot, sender) end)
	end

end

local function endRoll(msgTable, sender)
	sender = PLT:NS(sender)
	local eType, winner, MSNum, itemLink, _ = unpack(msgTable)
	MSNum = tonumber(MSNum)
	local i = slotAssoc[sender]
	local f = RollFrames[i]
	
	if MSNum and MSNum ~= 100 then
		PLT:ClearUseNumber(MSNum)
	end

	if not f then
		if winner and PLT:NS(winner) == GetUnitName("player") then
			--If you won the roll but closed the window then
			--create a "fake" item roll frame so we can change it into a trade window
			--PLT:DebugPrint("Creating fake Roll Frame.")
			local msgTable = {"", itemLink, -1, -1, -1, "", ""}
			startNewItemRoll(100, sender, msgTable, itemLink, true)
			i = slotAssoc[sender]
		else
			return
		end
	end

	PLT:DebugPrint(winner.. " won.")
	
	if winner == "nil" then --If the senders loot box was closed out or the player logged out
		PLT:RemoveSlot(i)
        PLT:CancelBarTimer(RollFrames[i].ProgressBar)
        --PLT:SetBarTimer()
	elseif  PLT:NS(winner) == GetUnitName("player") then --if you win
		PLT:SetUpRollOver(i, true, format(L["S_HAVE_WON"], PLT:NS(sender)))
		EF:RegisterEvent("TRADE_SHOW")
		PLT:CancelHideTimer(i)
		updateTradeButton(i, sender)
	else --someone else won
		PLT:SetUpRollOver(i, false, format(L["S_HAS_WON"], PLT:NS(winner)))
		RollFrames[i].hideTimer = C_Timer.NewTimer(5, function() PLT:RemoveSlot(i) end)
	end

	updateFrameHeight()

end

function EF:CHAT_MSG_ADDON(...)
	local prefix, message, event, sender = ...; --remove server because it gets too confusing since trading doesnt show server name
	
    if prefix == "RCLC" then
        --print(unpack(message))
        --hooksecurefunc(RCLootCouncil.TradeUI, "OnAwardReceived", testFunc)
        --print(message)
    end

	if prefix ~= "PLTrader2" then return end

	PLT:DebugPrint(message)
	sender = PLT:NS(sender)
	
	local msgTable = { strsplit('~', message) }
	
	local eType = msgTable[1]
	
	if not eType then return end

	if eType == "Start" then-- ((PLT:NS(sender) ~= PLT:NS(UnitName("player"))) or PLTrader.db.profile.general.debugging) then --Getting a new roll
		if #msgTable ~= 7 then
			PLT:Print(L["S_ROLL_ERROR"])
			return
		end
		
		--Kinda messy sending a table and the variables unpacked from the table
		local _, itemLink, _, MSNum = unpack(msgTable)
		MSNum = tonumber(MSNum)
		startNewItemRoll(MSNum, sender, msgTable, itemLink)
		
	elseif eType == "End" then --Roll is over
		endRoll(msgTable, sender)
	end
end

local tradeReceiver

function EF:TRADE_SHOW()
	tradeReceiver = TradeFrameRecipientNameText:GetText()
	
	-- local _, realm = UnitName(tradeReceiver)
	-- if not realm then realm = GetRealmName() end
	
	-- if realm then tradeReceiver = tradeReceiver.."-"..realm end
	
	--Too much trouble getting the server if they left the group & I doubt anyone will have the same name anyway
	
	PLT:DebugPrint("Trade opened by " .. tradeReceiver)
	
	EF:RegisterEvent("TRADE_CLOSED")
end

function EF:TRADE_CLOSED()
	C_Timer.After(2, function() PLTrader:RollTradeClosed(tradeReceiver) end)
	EF:UnregisterEvent("TRADE_CLOSED")
end

local function AttemptTrade(slot)
	local sender = PLT:NS(RollFrames[slot].storage.sender)
	local inRange = CheckInteractDistance(sender, 2);
	EF:RegisterEvent("TRADE_SHOW")
	--TargetUnit(PLT.PLT:NS(Winner));
	if inRange then
		InitiateTrade(sender);
	else
		inRange = CheckInteractDistance(sender, 4);
		if inRange then
			FollowUnit(sender)
		end
	
	end
end

function PLT:CancelHideTimer(i)
	if RollFrames[i].hideTimer then RollFrames[i].hideTimer:Cancel() end
end

function PLT:RemoveSlot(i) --Gets rid of loot in slot passed
	if not RollFrames[i] then return end

	PLT:CancelHideTimer(i)
	PLT:CancelBarTimer(RollFrames[i].ProgressBar)

	slotsOpen[i] = nil
	
	if slotAssoc[RollFrames[i].storage.sender] then slotAssoc[RollFrames[i].storage.sender] = nil end

	updateFrameHeight()
	
	RollFrames[i]:Hide()
	RollFrames[i].storage = {}
	RollFrames[i].awaitingTrade = false
	updateFrameHeight()

end

local function RollIsDone(slot)
--come back here
	if RollFrames[slot] then
		if RollFrames[slot].storage.addon == "Chat" then
			PLT:RemoveSlot(slot)
		else
		
		RollFrames[slot].PassButton:Hide()
		RollFrames[slot].WinnerText:Show()
		end
	end
end


local function CancelAllRolls()
	-- for i = 1, MAX_ROLLS do --Why did I not to do this in pairs?
		-- if RollFrames[i] and RollFrames[i].storage.sender then
			-- PLT:RemoveSlot(i)
		-- end
	-- end
	
	for i, frame in pairs(RollFrames) do
		if RollFrames[i].storage.sender then
			PLT:RemoveSlot(i)
		end
	end
	
end

local function GetPrimaryStat(item)
	local stats = GetItemStats(item)
	if stats ~= nil then
		for stat, value in pairs(stats) do
			if _G[stat] == ITEM_MOD_STRENGTH_SHORT or _G[stat] == ITEM_MOD_INTELLECT_SHORT or _G[stat] == ITEM_MOD_AGILITY_SHORT then
				return _G[stat]
			end
		end
	end
	return nil
end

local function getILVL()
	local ITEM_LEVEL_PATTERN = _G.ITEM_LEVEL:gsub('%%d', '(%%d+)')
	local ilvl = nil
	for i=2, 3 do
		local line = _G["PLTScanTooltipTextLeft"..i]:GetText()
		if line then
			ilvl = line:match(ITEM_LEVEL_PATTERN)
			if ilvl then return ilvl end
		end
		
	end
end

function PLT:CreateAndSetLootTooltip(item)
	PLT.scanTooltip = PLT.scanTooltip or CreateFrame("GameTooltip", "PLTScanTooltip", nil, "GameTooltipTemplate")
    PLT.scanTooltip:SetOwner(UIParent, "ANCHOR_NONE")
	PLT.scanTooltip:ClearLines()
	PLT.scanTooltip:SetHyperlink(item)

end

function PLT:GetMainStats(item)

	-- local realILVL = PLT:GetILVLFromTooltip(tooltipLong)
	-- if realILVL == nil then  -- if we still couldn't find it (shouldn't happen), just use the base ilvl we got from GetItemInfo()
		-- realILVL = itemLevel
	-- end
	
	-- realILVL = tonumber(realILVL)
	
	PLT:CreateAndSetLootTooltip(item)
	
	--local realILVL = getILVL() or 0
	
	local classes = nil
	local hasBindTradeTimeWarning = nil
	local hasSocket = false
	local hasAvoidance = false
	local hasIndestructible = false
	local hasLeech = false
	local hasSpeed = false
	local xmoggable = false
	local isAzeriteItem = false
	local hasAgi = false
	local hasInt = false
	local hasStr = false

	local lines = PLT.scanTooltip:NumLines()
    for i=2, lines do
        local line = _G["PLTScanTooltipTextLeft"..i]:GetText()
        if line then
			--hasBindTradeTimeWarning = hasBindTradeTimeWarning or text:match(BIND_TRADE_TIME_REMAINING_PATTERN)
			classes = classes or line:match(ITEM_CLASSES_ALLOWED_PATTERN)
			hasSocket = hasSocket or line:find(_G.EMPTY_SOCKET_PRISMATIC) == 1
			hasAgi = hasAgi or line:find(_G.ITEM_MOD_AGILITY_SHORT)
			hasInt = hasInt or line:find(_G.ITEM_MOD_INTELLECT_SHORT)
			hasStr = hasStr or line:find(_G.ITEM_MOD_STRENGTH_SHORT)
			--hasAvoidance = hasAvoidance or text:find(_G.STAT_AVOIDANCE) ~= nil
			--hasIndestructible = hasIndestructible or text:find(_G.STAT_STURDINESS) == 1
			--hasLeech = hasLeech or text:find(_G.STAT_LIFESTEAL) ~= nil
			--hasSpeed = hasSpeed or text:find(_G.STAT_SPEED) ~= nil
			--xmoggable = xmoggable or text:find(TRANSMOGRIFY_TOOLTIP_APPEARANCE_UNKNOWN_PATTERN) ~= nil or text:find(TRANSMOGRIFY_TOOLTIP_ITEM_UNKNOWN_APPEARANCE_KNOWN_PATTERN) ~= nil
			--isAzeriteItem = isAzeriteItem or text:match(TOOLTIP_AZERITE_UNLOCK_LEVELS_PATTERN) ~= nil or text:match(CURRENTLY_SELECTED_AZERITE_POWERS_PATTERN) ~= nil
        end
    end

	local itemTooltipInfo = {mainStats = {}, ilvl = realILVL}
	itemTooltipInfo.realILVL = realILVL

    if classes ~= nil then
		classes = string.upper(classes)
		classes = string.gsub(classes, ' ', '')  -- remove space for DEMON HUNTER, DEATH KNIGHT
        classes = { strsplit(",", classes) }
        itemTooltipInfo.classes = classes
    end
    
	if hasAgi or hasInt or hasStr then
		if hasAgi then
			itemTooltipInfo.mainStats[_G.ITEM_MOD_AGILITY_SHORT] = true
		end
		if hasInt then
			itemTooltipInfo.mainStats[_G.ITEM_MOD_INTELLECT_SHORT] = true
		end
		if hasStr then
			itemTooltipInfo.mainStats[_G.ITEM_MOD_STRENGTH_SHORT] = true
		end

	else
		itemTooltipInfo.mainStats = nil
	end
	
	return itemTooltipInfo
end

local function getEnabledIDs()
	for ID, _ in pairs(PLT.specIDs) do
		if PLTrader.db.profile.roller[PLT.name][ID] then
			PLT.enabledIDs[ID] = true
		end
	end
	canUse = {stats = {}, weapons = {}, armor = {}}

	for ID, _ in pairs(PLT.enabledIDs) do
		ID = tonumber(ID)
		for _, stat in pairs(STAT_BY_SPEC[ID]) do
			canUse.stats[stat] = true
		end
		
		for _, weaponType in pairs(WEAPON_BY_SPEC[ID]) do
			canUse.weapons[weaponType] = true
		end
		
		for _, armorType in pairs(ARMOR_BY_SPEC[ID]) do
			canUse.armor[armorType] = true
		end
		
		if OFFHANDS_USABLE[ID] then canUse.offhand = true end
	end
	
end

local function trinketCanBeUsed(item)
	local tooltipInfo = PLT:GetMainStats(item)
	if tooltipInfo.mainStats then
		for stat, k in pairs(tooltipInfo.mainStats) do
			if canUse.stats[stat] then
				PLT:DebugPrint("It's equippable")
				return true
			end
		end
	else
		return true
	end

end

local function isEquippable(itemSubClassID, itemEquipLoc, itemType, item)
	if not PLT.enabledIDs then PLT.enabledIDs = {} getEnabledIDs() end

	--if itemEquipLoc == "" then return end
	
	PLT:DebugPrint("EquipLoc: " .. itemEquipLoc .. ", Type: " .. itemType..", Sub Class ID: ".. itemSubClassID)
	
	if itemEquipLoc == "INVTYPE_FINGER" or itemEquipLoc == "INVTYPE_NECK" or itemEquipLoc == "INVTYPE_CLOAK" then
		return true
	end

	if itemEquipLoc == "INVTYPE_TRINKET" then
		--If the trinket has a main stat then show it if it's a usable stat
		--If there is no main stat just show it anyway.
		--I think you have to hard code every trinket to make this better?
		if trinketCanBeUsed(item) then return true end
        return
	end

	if itemEquipLoc == "INVTYPE_HOLDABLE" and canUse.offhand then return true end

    local tooltipInfo = PLT:GetMainStats(item)

    if tooltipInfo.classes then
        local className = select(2, GetClassInfo(select(3, UnitClass("player"))))

        for i, itemClassName in ipairs(tooltipInfo.classes) do
            if itemClassName == className then return true end
        end

        return
    end

	local checkTable = (itemType == 4 and canUse.armor) or (itemType == 2 and canUse.weapons) or {}

	if not checkTable[itemSubClassID] then PLT:DebugPrint("Can't be Equipped") return end

	if tooltipInfo.mainStats then
		for stat, k in pairs(tooltipInfo.mainStats) do
			if canUse.stats[stat] then
				PLT:DebugPrint("It's equippable")
				return true
			end
		end
	else
		return true
	end
	
	PLT:DebugPrint("Can't be Equipped")
	
	return false
	
end

local function updateSlotInfo(slot, item, force) --you have the item info

	local _, itemLink, itemRarity, itemLevel, _, itemType, _, _,
	itemEquipLoc, iconFileDataID, _, itemClassID, itemSubClassID, _, _, _, 
	_ = GetItemInfo(item)

	if isEquippable(itemSubClassID, itemEquipLoc, itemClassID, item) or force or PLTrader.db.profile.general.debugging then
		
		-- local realILVL = PLT:GetILVLFromTooltip(PLT.scanTooltip)
		-- if realILVL == nil then  -- if we still couldn't find it (shouldn't happen), just use the base ilvl we got from GetItemInfo()
			-- realILVL = itemLevel
		-- end
		
		PLT:CreateAndSetLootTooltip(item) --Create the tooltip for getILVL to work
		
		local realILVL = getILVL() or realILVL
		
		updateFrameHeight()
		RollFrames[slot]:Show()
		
		RollFrames[slot].storage.itemLink = itemLink --This item link is needed to check if its in your bag?
		
		RollFrames[slot].ntex:SetTexture(iconFileDataID)
		RollFrames[slot].ntex:SetTexCoord(0.08, 0.92, 0.08, 0.92)
		RollFrames[slot].ntex:SetAllPoints()
		RollFrames[slot].Loot:SetNormalTexture(RollFrames[slot].ntex)
		r, g, b, hex = GetItemQualityColor(itemRarity)		
		RollFrames[slot].LootBorder:SetBackdropColor (r, g, b, 1)
		RollFrames[slot].LootBorder:SetBackdropBorderColor (r, g, b, .5)
		
		RollFrames[slot].Loot:SetText(realILVL)
		
		return true
	else
		PLT:RemoveSlot(slot)
	end
end

function PLTrader:RollTradeClosed(tradeReceiver)
	if not tradeReceiver then return end
	
	PLT:DebugPrint("Trader: ".. tradeReceiver)
	
	local slot = slotAssoc[tradeReceiver]

	if not slot then return end
	
	PLT:DebugPrint("SLOT: ".. slot)
	
	canTrade, _, _ = PLT:IsTradeable(RollFrames[slot].storage.itemLink)
	
	PLT:DebugPrint(RollFrames[slot].storage.itemLink)
	
	if canTrade then
		PLT:DebugPrint("Item Found. Closing.")
		PLT:RemoveSlot(slot)
	else
		PLT:DebugPrint("Item NOT found.")
	end
	
end

function PLTrader:MessageCheck() --There's probably a better way but screw it

end

function PLT:ChangeReceive()

    --turning off recieve breaks a lot of stuff I need to take this out
    EF:RegisterEvent("CHAT_MSG_ADDON")

	--if self.db.profile.roller.receive then
	--	EF:RegisterEvent("CHAT_MSG_ADDON")
	--else
	--	EF:UnregisterEvent("CHAT_MSG_ADDON")
	--end
end

function PLT:CreateRollerFrames()

	PLRFrame = CreateFrame ("frame", nil, UIParent, "BackdropTemplate")
	PLT.RF = PLRFrame
	PLRFrame:SetSize (200, 25)
	PLRFrame:SetBackdrop ({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 16, edgeFile = [[Interface\ButtoPLRFrame.NS\WHITE8X8]], edgeSize = 2})
	PLRFrame:SetBackdropColor (0, 0, 0, 0)
	
	PLRFrame:SetBackdropBorderColor (0, 0, 0, 0)
	
	--PLT:SetDefaultLocation()
	PLT:UpdateFramePositions()	
	
	PLRFrame:EnableMouse (true)
	PLRFrame:SetMovable (true)
	PLRFrame:Hide()
	PLRFrame:SetScript("OnMouseDown", function(self, button)
	
	
	if button == "LeftButton" and not self.isMoving then
	   self:StartMoving();
	   self.isMoving = true;
	  end
	end)
	PLRFrame:SetScript("OnMouseUp", function(self, button)
	  if button == "LeftButton" and self.isMoving then
	   self:StopMovingOrSizing();
	   self.isMoving = false;
	   
	   --local point, relativeTo, relativePoint, xOfs, yOfs = PLRFrame:GetPoint(1)
	   
	   local scale = PLTrader.db.profile.general.scale
	   
	   PLTrader.db.profile.roller.xoff = PLT:Round(self:GetLeft()*scale, 0)
	   PLTrader.db.profile.roller.yoff  = PLT:Round(self:GetTop()*scale, 0)
	   
	  end
	end)
	PLRFrame:SetScript("OnHide", function(self)
	  if ( self.isMoving ) then
	   self:StopMovingOrSizing();
	   self.isMoving = false;
	  end
	end)
	
	
	--Title bar
	PLRFrame.TitleBar = CreateFrame ("frame", "PLRTitleBar", PLRFrame, "BackdropTemplate")
	PLRFrame.TitleBar:SetPoint ("topleft", PLRFrame, "topleft", 2, -3)
	PLRFrame.TitleBar:SetPoint ("topright", PLRFrame, "topright", -2, -3)
	PLRFrame.TitleBar:SetHeight(20)
	PLRFrame.TitleBar:EnableMouse (false)
	PLRFrame.TitleBar:SetBackdrop ({edgeFile = [[Interface\Buttons\WHITE8X8]], edgeSize = 2, bgFile = [[Interface\Tooltips\UI-Tooltip-Background]], tileSize = 64, tile = true})
	PLRFrame.TitleBar:SetBackdropColor (.2, .2, .2, .5)
	PLRFrame.TitleBar:SetBackdropBorderColor (0, 0, 0, .7)
	
	
	PLRFrame.Backdrop = CreateFrame ("frame", "PLRFrameBackdrop", PLRFrame, "BackdropTemplate")
	PLRFrame.Backdrop:SetSize (206, 0)
	PLRFrame.Backdrop:SetPoint ("TOPLEFT", PLRFrame, "TOPLEFT", -3, 0)
	PLRFrame.Backdrop:SetBackdrop ({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 16, edgeFile = [[Interface\ButtoPLRFrame.NS\WHITE8X8]], edgeSize = 2})
	--PLRFrame.Backdrop:SetBackdropColor (0, 0, 0, .5)
	PLRFrame.Backdrop:SetBackdropColor (0, 0, 0, 1)
	PLRFrame.Backdrop:SetBackdropBorderColor (0, 0, 0, 1)
	
	-- title text
	PLRFrame.Title = PLRFrame.TitleBar:CreateFontString ("$parentRTitle", "overlay", "GameFontNormal")
	PLRFrame.Title:SetPoint ("center", PLRFrame.TitleBar, "center")
	PLRFrame.Title:SetTextColor (.8, .8, .8, 1)
	PLRFrame.Title:SetText (L["S_ROLLER_NAME"])

	PLRFrame.AnchorFrame = CreateFrame ("frame", nil, PLRFrame)
	PLRFrame.AnchorFrame:SetAllPoints()
	PLRFrame.AnchorFrame:SetFrameLevel (PLRFrame:GetFrameLevel()+3)
	
	--Close Button
	PLRFrame.Close = CreateFrame ("button", nil, PLRFrame)
	PLRFrame.Close:SetPoint ("right", PLRFrame.TitleBar, "right", -2, 0)
	PLRFrame.Close:SetSize (16, 16)
	PLRFrame.Close:SetNormalTexture (PLT.ICONPATH)
	PLRFrame.Close:SetHighlightTexture (PLT.ICONPATH)
	PLRFrame.Close:SetPushedTexture (PLT.ICONPATH)
	PLRFrame.Close:GetNormalTexture():SetTexCoord (0, 16/128, 0, 1)
	PLRFrame.Close:GetHighlightTexture():SetTexCoord (0, 16/128, 0, 1)
	PLRFrame.Close:GetPushedTexture():SetTexCoord (0, 16/128, 0, 1)
	PLRFrame.Close:SetAlpha (0.7)
	PLRFrame.Close:SetScript ("OnClick", function() CancelAllRolls() end)
	
	--Message Text
	PLRFrame.MsgText = PLRFrame:CreateFontString ("$parentTitle", "overlay", "GameFontNormal")
	PLRFrame.MsgText:SetWidth(120)
	PLRFrame.MsgText:SetHeight(100)
	PLRFrame.MsgText:SetJustifyH("LEFT")
	PLRFrame.MsgText:SetJustifyV("TOP")
	PLRFrame.MsgText:SetPoint ("RIGHT", PLRFrame, "RIGHT", 120, 0)
	PLRFrame.MsgText:SetTextColor (.8, .8, .8, 1)
	PLRFrame.MsgText:Hide()
	
	PLRFrame:SetScript ("OnShow", function() PLTrader:MessageCheck() end)
	
end


function PLT:UpdateChatEvents()
	
	if self.db.profile.roller.searchchat then
		ECP:RegisterEvent("CHAT_MSG_RAID")
		ECP:RegisterEvent("CHAT_MSG_PARTY_LEADER")
		ECP:RegisterEvent("CHAT_MSG_PARTY")
		ECP:RegisterEvent("CHAT_MSG_RAID_LEADER")
		ECP:RegisterEvent("CHAT_MSG_INSTANCE_CHAT")
		ECP:RegisterEvent("CHAT_MSG_INSTANCE_CHAT_LEADER")
	else
		ECP:UnregisterAllEvents()
	end

end


function PLT:ChatParse(self, event, ...)

	local message, sender = ...
	--Don't parse your own messages
	if PLT:NS(sender) == UnitName("player") then return end
	
	local itemLink = message:match("|%x+|Hitem:.-|h.-|h|r") 
	if not itemLink then return end --if item link found in message
	
	local capMessage = strupper(message)
	
	local addToRoll = false
	for i = 1, #L["S_OFFER_WORDS"] do --search for words that ppl use to offer loot
		if string.find(capMessage, L["S_OFFER_WORDS"][i]) then --if it found a word
			 --if it's not from PLT
			if not string.find(capMessage, L["S_SEARCH_ABREV"]) then 
				addToRoll = true
			end
		end
	end
	
	if not addToRoll then return end
	
	for i = 1, #L["S_IGNORE_WORDS"] do --"rolled" contains "roll" ignore these messages
		if string.find(strupper(capMessage), L["S_IGNORE_WORDS"][i]) then --if it found a word
			return
		end
	end
		
	local rollNumMessage = capMessage:match(L["S_ROLL"].." (%d+)")
	if rollNumMessage then
		rollNumMessage = tonumber(rollNumMessage)	
	else
		rollNumMessage = 100
	end
	
	--Return if the message is from the addon
	
	local i = 0
	local f
	
	repeat
		i=i+1
		f = RollFrames[i]
	until not f or (f and not f.storage.sender)
	
	local item = Item:CreateFromItemLink(itemLink)
	slotsOpen[i] = false
	local msgTable = {"Start", itemLink, -1, rollNumMessage, -1, "/"..string.lower(L["S_ROLL"]).." " .. rollNumMessage, ""}
	
	item:ContinueOnItemLoad(function()
		local f = PLT:CreateLootFrame(i, msgTable, "Chat", sender)
		if not f then return end
		message = message:gsub("|%x+|Hitem:.-|h.-|h|r", "")
		f.storage.message = message
	end)
	--AddNewItem(itemLink, rollNumMessage, user, PLTrader.db.profile.roller.searchchattime, "CHAT", message)
	
end

function PLT:SetUpRollOver(i, trade, text)
	--if not i then return end --rolled on an item you can't trade. Trade window won't show
	if trade then
		RollFrames[i].TradeButton:Show()
	else
		RollFrames[i].TradeButton:Hide()
	end
	RollFrames[i].WinnerText:SetText(text)
	RollFrames[i].awaitingTrade = trade
	RollFrames[i].BC:Hide()
	RollFrames[i].RC:Show()
end


ECP:SetScript("OnEvent", function(self, event, ...) PLT:ChatParse(self, event, ...) end)

local function SendEnterRoll(i, type)
	if RollFrames[i].storage.addon == "PLT" then--or RollFrames[i].addon == "PLH" then
		--print(RollFrames[i].playerName)		--SendChatMessage(Type, "WHISPER", nil, RollFrames[i].playerName)
		if type == MSAbrev then
			RandomRoll(1, RollFrames[i].storage.MSNum)
		else
			RandomRoll(1, RollFrames[i].storage.OSNum)
		end
		
	else --it's from chat
		RandomRoll(1, RollFrames[i].storage.MSNum)
		PLT:RemoveSlot(i)
	end
	
	PLT:SetUpRollOver(i)
	PLT:CancelHideTimer(i)

	local explainText = L["S_AWAITING_WINNER"]
	if RollFrames[i].addon == "PLH" then --old code keeping for later?
		explainText = explainText .." "..L["S_ANOTHER_ADDON"]
	else
		explainText = explainText .."."
	end
	RollFrames[i].WinnerText:SetText(explainText)
	RollFrames[i].awaitingTrade = false
	
end

local function ShowItemTooltip(i)

	GameTooltip:SetOwner (RollFrames[i].Loot, "ANCHOR_LEFT")
	GameTooltip:SetHyperlink(RollFrames[i].storage.itemLink)
	--GameTooltip:SetText ("why", nil, nil, nil, nil, true)
	GameTooltip:Show()
	
	GameTooltip_ShowCompareItem(GameTooltip)


end

local function HideItemTooltip()
	GameTooltip:Hide()
end

local function rollFrameMouseOver(enter, frame)
	if frame.storage.addon == "Chat" then
		PLT:ToggleInfoTooltip(enter, frame.storage.message, frame)
	end
end

local function createRollFrame(i)

	local frame = CreateFrame ("frame", nil, PLRFrame, "BackdropTemplate")

	frame:SetSize (200, 75)
	frame:SetBackdrop ({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 16, edgeFile = [[Interface\ButtoPLT_RollerLootFrame_i.NS\WHITE8X8]], edgeSize = 2})
	frame:SetBackdropColor (0, 0, 0, 1)
	frame:SetBackdropBorderColor (0, 0, 0, 1)
	frame:SetPoint ("topleft", PLRFrame, "topleft", 0, 54+(i*-78))
	frame:EnableMouse (true)
	frame:SetMovable (true)

	frame.length = length
	
	local ILVLFont = CreateFont("PLTILVLFont")
	--ILVLFont:CopyFontObject("GameFontNormal");
	ILVLFont:SetFont("Interface\\AddOns\\PersonalLootTrader\\media\\fonts\\Homespun.ttf", 25, "OUTLINE")
	ILVLFont:SetTextColor(1, 1, 1, 1.0);
	
	--loot button (loot icon with mouseover)
	frame.Loot = CreateFrame ("button", nil, frame)
	frame.Loot:SetPoint("TOPLEFT", frame, "TOPLEFT" , 5, -5)
	frame.Loot:SetWidth(64)
	frame.Loot:SetHeight(64)
	frame.Loot:SetNormalFontObject("GameFontNormal")
	frame.Loot:SetScript("OnEnter", function() ShowItemTooltip(i) end)
	frame.Loot:SetScript("OnLeave", function() HideItemTooltip(i) end)
	frame.ntex = frame.Loot:CreateTexture()
	
	frame.Loot:SetNormalFontObject(ILVLFont);

	--loot border
	frame.LootBorder = CreateFrame ("frame", nil, frame, "BackdropTemplate")
	frame.LootBorder:SetPoint ("TOPLEFT", frame, "TOPLEFT", 2, -2)
	frame.LootBorder:SetHeight(70)
	frame.LootBorder:SetWidth(70)
	frame.LootBorder:EnableMouse (false)
	frame.LootBorder:SetBackdrop ({edgeFile = [[Interface\Buttons\WHITE8X8]], edgeSize = 2, bgFile = [[Interface\Tooltips\UI-Tooltip-Background]], tileSize = 64, tile = true})
	frame.LootBorder:SetBackdropColor (1, 1, 1, 1)
	frame.LootBorder:SetBackdropBorderColor (1, 1, 1, .5)
	
	frame.BC = CreateFrame("Frame", nil, frame)
	
	--Main Spec Button
	frame.MSButton = PLT:CreateTextButton("MSButton", "", frame.BC , frame.LootBorder , "TOPLEFT", "TOPRIGHT", 5, 0, 70, 20)
	frame.MSButton:SetScript ("OnClick", function() SendEnterRoll(i, MSAbrev)  end)
	
	frame.OSButton = PLT:CreateTextButton("OSButton", "", frame.BC , frame.MSButton , "TOPLEFT", "BOTTOMLEFT", 0, -5, 70, 20)
	frame.OSButton:SetScript ("OnClick", function() SendEnterRoll(i , OSAbrev) end)
	
	frame.PassButton = PLT:CreateTextButton("PassButton", L["S_PASS"], frame.BC , frame.MSButton , "TOPLEFT", "TOPRIGHT", 5, 0, 45, 45)
	frame.PassButton:SetScript ("OnClick", function() PLT:RemoveSlot(i) end)

	local onEnterButtons = {frame, frame.MSButton, frame.OSButton, frame.PassButton}
	
	for _, enterFrame in pairs(onEnterButtons) do
		enterFrame:SetScript("OnEnter", function() rollFrameMouseOver(true, frame) end)
		enterFrame:SetScript("OnLeave", function() rollFrameMouseOver(false, frame) end)
	end
	
	frame.RC = CreateFrame("Frame", nil, frame)
	
	--Winner Text
	frame.WinnerText = frame.RC:CreateFontString ("$parentTitle", "overlay", "GameFontNormal")
	frame.WinnerText:SetWidth(115)
	frame.WinnerText:SetHeight(100)
	frame.WinnerText:SetJustifyH("LEFT")
	frame.WinnerText:SetJustifyV("TOP")
	frame.WinnerText:SetPoint ("TOPLEFT", frame, "TOPLEFT", 80, 0)
	frame.WinnerText:SetTextColor (.8, .8, .8, 1)
	--TradeButton
	
	frame.TradeButton = PLT:CreateTextButton("TradeButton", "", frame.RC , frame.LootBorder, "BOTTOMLEFT", "BOTTOMRIGHT", 5, 0, 100, 20)
	frame.TradeButton:SetScript ("OnClick", function() AttemptTrade(i)  end)

	
	--Progress Bar
	frame.ProgressBar = PLT:CreateBar (frame, nil, 115, 16, 40)
	frame.ProgressBar:SetPoint ("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -5, 5)
	frame.ProgressBar:Hide()
	
	--RollFrames[i]:SetScript ("OnUpdate", function() PLTrader:MessageCheck(i) end)
	--RollFrames[i]:SetScript ("OnLeave", function() PLTrader:LootChatLeft(i) end)

	--local ptexture = LibStub:GetLibrary ("LibSharedMedia-3.0"):Fetch ("statusbar", "Iskar Serenity")
	--frame.ProgressBar.timer_texture:SetTexture ([[Interface\Buttons\WHITE8X8]])
	--PLT_RollerLootFrame_i.ProgressBar.background:SetTexture (ptexture)
	
	return frame
		
end

function PLT:CreateLootFrame(i, msgTable, addon, sender, force)
	local PLRFrameHeader = _G["PLRFrame"]
	
	local eType, itemLink, length, MSNum, OSNum, MSDesc, OSDesc = unpack(msgTable)
	MSNum = tonumber(MSNum)
	OSNum = tonumber(OSNum)
	
	if not PLRFrame then
		PLT:CreateRollerFrames()
	end
	if not RollFrames[i] then
		RollFrames[i] = createRollFrame(i)
	end
	
	local f = RollFrames[i]
	itemID, itemType, itemSubType, itemEquipLoc, iconFileDataID, _, _ = GetItemInfoInstant(itemLink)
	
	--RollFrames[i].MSButton:SetText(L["S_MainSpecAbreviation"])
	f.storage = {}
	f.storage.MSNum = MSNum
	f.storage.OSNum = OSNum

	f.BC:Show()
	f.RC:Hide()
	f.awaitingTrade = false
	--updateFrameHeight()
	
	if OSNum < 0 then
		f.OSButton:Hide()
	else
		f.OSButton:Show()
	end
	
	f.storage.itemLink = itemLink
	f.storage.sender = sender
	f.storage.addon = addon
	f.storage.itemID = itemID
	
	f.MSButton:SetText(MSDesc)
	f.OSButton:SetText(OSDesc)

	local slotExists = updateSlotInfo(i, itemLink, force)
	if not slotExists then return end

	if addon == "Chat" then length = PLTrader.db.profile.roller.searchchattime end

	if tonumber(length) > -1 then
        --f.ProgressBar:SetTimer(length-.5)
		f.ProgressBar:Show()
		PLT:SetBarTimer(f.ProgressBar, length-.5)
		f.hideTimer = C_Timer.NewTimer(length-.5, function() PLT:RemoveSlot(i) end)
	else
		f.ProgressBar:Hide()
	end
	
	return f

end



